public inbox for gentoo-dev@lists.gentoo.org
 help / color / mirror / Atom feed
From: Eric Joldasov <bratishkaerik@landless-city.net>
To: gentoo-dev@lists.gentoo.org
Cc: Eric Joldasov <bratishkaerik@getgoogleoff.me>
Subject: [gentoo-dev] [PATCH 3/5] dev-lang/zig: add 0.13.0-r1
Date: Thu, 24 Oct 2024 06:46:16 +0500	[thread overview]
Message-ID: <20241024014626.31175-4-bratishkaerik@landless-city.net> (raw)
In-Reply-To: <20241024014626.31175-1-bratishkaerik@landless-city.net>

From: Eric Joldasov <bratishkaerik@getgoogleoff.me>

* Update to use llvm-r1 eclass instead of llvm, zig-build and
  zig-toolchain functions instead of local get_zig_mcpu etc. functions.
* Port "llvm USE-flag" and "removing memory limit flags" from 9999
  ebuild.
* Stage3 compilation is unified by combining build.zig options,
  now both cmake (+llvm) and bootstrap.c (-llvm) build up to "zig2"
  target, after that we use zig-build.eclass with common options.
* Before migrating to the zig-build.eclass, test steps in src_test
  have been ran sequentially in for-loop, which allowed logic inside
  each step to ran parallelly but not several steps at a time. Now we use
  upstream "test" step instead of separately calling all dependant
  steps, so that build system can now ran all of them paralelly.
  This means time spent in src_test is now significantly shorter.
* "zig2" in both scenarios now has explicit target which is set by
  using zig-toolchain functions on a CBUILD/CHOST. This allows us
  to skip convertion logic in CMake and bootstrap.c, so that instead
  of patching them we can just update converter in zig-toolchain.eclass
  and unify target behaviour.
* Disable autodocs generation for "std" module, since it can now
  be generated on-fly with "zig std" command.

Signed-off-by: Eric Joldasov <bratishkaerik@landless-city.net>
---
 .../zig-0.13.0-skip-test-stack_iterator.patch |  32 +++
 dev-lang/zig/zig-0.13.0-r1.ebuild             | 242 ++++++++++++++++++
 2 files changed, 274 insertions(+)
 create mode 100644 dev-lang/zig/files/zig-0.13.0-skip-test-stack_iterator.patch
 create mode 100644 dev-lang/zig/zig-0.13.0-r1.ebuild

diff --git a/dev-lang/zig/files/zig-0.13.0-skip-test-stack_iterator.patch b/dev-lang/zig/files/zig-0.13.0-skip-test-stack_iterator.patch
new file mode 100644
index 000000000000..e088af2102ed
--- /dev/null
+++ b/dev-lang/zig/files/zig-0.13.0-skip-test-stack_iterator.patch
@@ -0,0 +1,32 @@
+From: Eric Joldasov <bratishkaerik@landless-city.net>
+
+Skip standalone test "stack_iterator" that fail on Gentoo Linux x86_64.
+Fails in ReleaseSafe, ReleaseFast and ReleaseSmall, but not in Debug.
+Reported to upstream here https://github.com/ziglang/zig/issues/19944 .
+
+Signed-off-by: Eric Joldasov <bratishkaerik@landless-city.net>
+
+diff --git a/test/standalone/stack_iterator/shared_lib_unwind.zig b/test/standalone/stack_iterator/shared_lib_unwind.zig
+index 57513a49c6..75fddb04c9 100644
+--- a/test/standalone/stack_iterator/shared_lib_unwind.zig
++++ b/test/standalone/stack_iterator/shared_lib_unwind.zig
+@@ -35,6 +35,7 @@ extern fn frame0(
+ ) void;
+
+ pub fn main() !void {
++    if (true) return;
+     // Disabled until the DWARF unwinder bugs on .aarch64 are solved
+     if (builtin.omit_frame_pointer and comptime builtin.target.isDarwin() and builtin.cpu.arch == .aarch64) return;
+
+diff --git a/test/standalone/stack_iterator/unwind.zig b/test/standalone/stack_iterator/unwind.zig
+index 69c463a0c1..40963af63d 100644
+--- a/test/standalone/stack_iterator/unwind.zig
++++ b/test/standalone/stack_iterator/unwind.zig
+@@ -87,6 +87,7 @@ noinline fn frame0(expected: *[4]usize, unwound: *[4]usize) void {
+ }
+
+ pub fn main() !void {
++    if (true) return;
+     // Disabled until the DWARF unwinder bugs on .aarch64 are solved
+     if (builtin.omit_frame_pointer and comptime builtin.target.isDarwin() and builtin.cpu.arch == .aarch64) return;
+
diff --git a/dev-lang/zig/zig-0.13.0-r1.ebuild b/dev-lang/zig/zig-0.13.0-r1.ebuild
new file mode 100644
index 000000000000..dee2be065321
--- /dev/null
+++ b/dev-lang/zig/zig-0.13.0-r1.ebuild
@@ -0,0 +1,242 @@
+# Copyright 2019-2024 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+LLVM_COMPAT=(18)
+LLVM_OPTIONAL=1
+
+ZIG_SLOT="$(ver_cut 1-2)"
+ZIG_OPTIONAL=1
+
+inherit check-reqs cmake flag-o-matic edo llvm-r1 toolchain-funcs zig-build
+
+DESCRIPTION="A robust, optimal, and maintainable programming language"
+HOMEPAGE="https://ziglang.org/ https://github.com/ziglang/zig/"
+if [[ ${PV} == 9999 ]]; then
+	EGIT_REPO_URI="https://github.com/ziglang/zig.git"
+	inherit git-r3
+else
+	VERIFY_SIG_METHOD=minisig
+	VERIFY_SIG_OPENPGP_KEY_PATH=/usr/share/minisig-keys/zig-software-foundation.pub
+	inherit verify-sig
+
+	SRC_URI="
+		https://ziglang.org/download/${PV}/${P}.tar.xz
+		verify-sig? ( https://ziglang.org/download/${PV}/${P}.tar.xz.minisig )
+	"
+	KEYWORDS="~amd64 ~arm ~arm64"
+
+	BDEPEND="verify-sig? ( sec-keys/minisig-keys-zig-software-foundation )"
+fi
+
+# project itself: MIT
+# There are bunch of projects under "lib/" folder that are needed for cross-compilation.
+# Files that are unnecessary for cross-compilation are removed by upstream
+# and therefore their licenses (if any special) are not included.
+# lib/libunwind: Apache-2.0-with-LLVM-exceptions || ( UoI-NCSA MIT )
+# lib/libcxxabi: Apache-2.0-with-LLVM-exceptions || ( UoI-NCSA MIT )
+# lib/libcxx: Apache-2.0-with-LLVM-exceptions || ( UoI-NCSA MIT )
+# lib/libc/wasi: || ( Apache-2.0-with-LLVM-exceptions Apache-2.0 MIT BSD-2 ) public-domain
+# lib/libc/musl: MIT BSD-2
+# lib/libc/mingw: ZPL public-domain BSD-2 ISC HPND
+# lib/libc/glibc: BSD HPND ISC inner-net LGPL-2.1+
+LICENSE="MIT Apache-2.0-with-LLVM-exceptions || ( UoI-NCSA MIT ) || ( Apache-2.0-with-LLVM-exceptions Apache-2.0 MIT BSD-2 ) public-domain BSD-2 ZPL ISC HPND BSD inner-net LGPL-2.1+"
+SLOT="${ZIG_SLOT}"
+IUSE="doc +llvm test"
+RESTRICT="!test? ( test )"
+REQUIRED_USE="
+	!llvm? ( !doc )
+	llvm? ( ${LLVM_REQUIRED_USE} )
+"
+
+# Used by both cmake and zig-build eclass.
+BUILD_DIR="${WORKDIR}/${P}_build"
+
+# Zig requires zstd and zlib compression support in LLVM, if using LLVM backend.
+# (non-LLVM backends don't require these)
+# They are not required "on their own", so please don't add them here.
+# You can check https://github.com/ziglang/zig-bootstrap in future, to see
+# options that are passed to LLVM CMake building (excluding "static" ofc).
+DEPEND="
+	llvm? (
+		$(llvm_gen_dep '
+			sys-devel/clang:${LLVM_SLOT}
+			sys-devel/lld:${LLVM_SLOT}
+			sys-devel/llvm:${LLVM_SLOT}[zstd]
+		')
+	)
+"
+BDEPEND+="
+	test? ( !!<sys-apps/sandbox-2.39 )
+	${DEPEND}
+"
+RDEPEND="${DEPEND}"
+IDEPEND="app-eselect/eselect-zig"
+
+DOCS=("README.md" "doc/build.zig.zon.md")
+
+PATCHES=(
+	"${FILESDIR}/zig-0.13.0-test-std-kernel-version.patch"
+	"${FILESDIR}/zig-0.13.0-skip-test-stack_iterator.patch"
+)
+
+# zig-build does not set this for us since we use ZIG_OPTIONAL=1
+QA_FLAGS_IGNORED="usr/.*/zig/${PV}/bin/zig"
+
+# Since commit https://github.com/ziglang/zig/commit/e7d28344fa3ee81d6ad7ca5ce1f83d50d8502118
+# Zig uses self-hosted compiler only
+CHECKREQS_MEMORY="4G"
+
+pkg_setup() {
+	# Skip detecting zig executable.
+	ZIG_EXE="not-applicable" ZIG_VER="${PV}" zig-build_pkg_setup
+
+	export ZIG_SYS_INSTALL_DEST="${EPREFIX}/usr/$(get_libdir)/zig/${PV}"
+
+	if use llvm; then
+		tc-is-cross-compiler && die "USE=llvm is not yet supported when cross-compiling"
+		llvm-r1_pkg_setup
+	fi
+
+	check-reqs_pkg_setup
+}
+
+src_unpack() {
+	if [[ ${PV} == 9999 ]]; then
+		git-r3_src_unpack
+	else
+		verify-sig_src_unpack
+	fi
+}
+
+src_prepare() {
+	# Avoid double patching. Copied from net-misc/sunshine-0.23.1::gentoo .
+	default_src_prepare
+	default_src_prepare() { :; }
+
+	use llvm && cmake_src_prepare
+	zig-build_src_prepare
+
+	# Remove "limit memory usage" flags, it's already verified by
+	# CHECKREQS_MEMORY and causes unneccessary errors. Upstream set them
+	# according to CI OOM failures, which are not applicable to normal Gentoo build.
+	sed -i -e '/\.max_rss = .*,/d' build.zig || die
+}
+
+src_configure() {
+	# Has no effect on final binary and only causes failures during bootstrapping.
+	filter-lto
+
+	# Used during bootstrapping. stage1/stage2 have limited functionality
+	# and can't resolve native target, so we pass target in exact form.
+	declare -r -g ZIG_HOST_AS_TARGET=$(zig-toolchain_get_target ${CBUILD:-${CHOST}})
+
+	# Note that if we are building with CMake, "my_zbs_args"
+	# are used only after compiling zig2.
+	local my_zbs_args=(
+		--zig-lib-dir "${S}/lib/"
+		# Will be a subdir under ZIG_SYS_INSTALL_DEST.
+		--prefix-lib-dir lib/
+
+		# These are built separately
+		-Dno-langref
+		-Dstd-docs=false
+
+		--release=fast
+	)
+	if use llvm; then
+		my_zbs_args+=(
+			-Denable-llvm=true
+			-Dstatic-llvm=false
+			-Dconfig_h="${BUILD_DIR}/config.h"
+		)
+	else
+		my_zbs_args+=(
+			-Denable-llvm=false
+		)
+	fi
+
+	zig-build_src_configure
+
+	if use llvm; then
+		# Build for native only, it's for zig2 (build-time executable)
+		# LLVM from BDEPEND
+		local mycmakeargs=(
+			-DZIG_SHARED_LLVM=ON
+			-DZIG_USE_LLVM_CONFIG=ON
+
+			-DZIG_TARGET_TRIPLE=native
+			-DZIG_TARGET_MCPU=native
+			-DZIG_HOST_TARGET_TRIPLE=${ZIG_HOST_AS_TARGET}
+
+			-DCMAKE_PREFIX_PATH="$(get_llvm_prefix -b)"
+			-DCMAKE_INSTALL_PREFIX="${ZIG_SYS_INSTALL_DEST}"
+		)
+
+		cmake_src_configure
+	fi
+}
+
+src_compile() {
+	if use llvm; then
+		cmake_build zig2
+	else
+		cd "${BUILD_DIR}" || die
+		ln -s "${S}/stage1/" . || die
+		ln -s "${S}/src/" . || die
+		ln -s "${S}/lib/" . || die
+
+		local native_cc="$(tc-getBUILD_CC)"
+		"${native_cc}" -o bootstrap "${S}/bootstrap.c" || die "Zig's bootstrap.c compilation failed"
+		ZIG_HOST_TARGET_TRIPLE=${ZIG_HOST_AS_TARGET} CC="${native_cc}" edob ./bootstrap
+	fi
+
+	cd "${BUILD_DIR}" || die
+	ZIG_EXE="./zig2" zig-build_src_compile --prefix "${BUILD_DIR}/stage3/"
+
+	./stage3/bin/zig env || die "Zig compilation failed"
+
+	if use doc; then
+		ZIG_EXE="./stage3/bin/zig" zig-build_src_compile langref --prefix "${S}/docgen/"
+	fi
+}
+
+src_test() {
+	cd "${BUILD_DIR}" || die
+	ZIG_EXE="./stage3/bin/zig" zig-build_src_test -Dskip-non-native
+}
+
+src_install() {
+	use doc && local HTML_DOCS=("docgen/doc/langref.html")
+
+	ZIG_EXE="./zig2" zig-build_src_install --prefix "${ZIG_SYS_INSTALL_DEST}"
+
+	cd "${D}/${ZIG_SYS_INSTALL_DEST}" || die
+	mv lib/zig/ lib2/ || die
+	rm -rf lib/ || die
+	mv lib2/ lib/ || die
+	dosym -r "${ZIG_SYS_INSTALL_DEST}/bin/zig" /usr/bin/zig-${PV}
+}
+
+pkg_postinst() {
+	eselect zig update ifunset || die
+
+	elog "Starting from 0.12.0, Zig no longer installs"
+	elog "precompiled standard library documentation."
+	elog "Instead, you can call \`zig std\` to compile it on-the-fly."
+	elog "It reflects all edits in standard library automatically."
+	elog "See \`zig std --help\` for more information."
+	elog "More details here: https://ziglang.org/download/0.12.0/release-notes.html#Redesign-How-Autodoc-Works"
+
+	if ! use llvm; then
+		elog "Currently, Zig built without LLVM support lacks some"
+		elog "important features such as most optimizations, @cImport, etc."
+		elog "They are listed under \"Building from Source without LLVM\""
+		elog "section of the README file from \"/usr/share/doc/${PF}\" ."
+	fi
+}
+
+pkg_postrm() {
+	eselect zig update ifunset || die
+}
-- 
2.47.0



  parent reply	other threads:[~2024-10-24  1:47 UTC|newest]

Thread overview: 29+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2024-10-24  1:46 [gentoo-dev] [PATCH 0/5] Ziglang eclasses for 0.13+ Eric Joldasov
2024-10-24  1:46 ` [gentoo-dev] [PATCH 1/5] zig-toolchain.eclass: new eclass Eric Joldasov
2024-10-24  7:32   ` Ulrich Müller
2024-10-24  7:38     ` Matt Jolly
2024-10-24  8:50       ` Florian Schmaus
2024-10-24 13:00         ` Michael Orlitzky
2024-10-24  1:46 ` [gentoo-dev] [PATCH 2/5] zig-build.eclass: " Eric Joldasov
2024-10-24  9:16   ` Maciej Barć
2024-10-24  1:46 ` Eric Joldasov [this message]
2024-10-24  1:46 ` [gentoo-dev] [PATCH 4/5] dev-lang/zig: sync 9999 with 0.13.0-r1 Eric Joldasov
2024-10-24  1:46 ` [gentoo-dev] [PATCH 5/5] sys-fs/ncdu: add 2.6-r1 Eric Joldasov
2024-10-25 21:20 ` [gentoo-dev] [PATCH 0/5] Ziglang eclasses for 0.13+ Eric Joldasov
2024-10-25 21:20   ` [gentoo-dev] [PATCH 1/5] zig-toolchain.eclass: new eclass Eric Joldasov
2024-10-25 21:20   ` [gentoo-dev] [PATCH 2/5] zig-build.eclass: " Eric Joldasov
2024-10-25 21:20   ` [gentoo-dev] [PATCH 3/5] dev-lang/zig: add 0.13.0-r1 Eric Joldasov
2024-10-25 21:20   ` [gentoo-dev] [PATCH 4/5] dev-lang/zig: sync 9999 with 0.13.0-r1 Eric Joldasov
2024-10-25 21:20   ` [gentoo-dev] [PATCH 5/5] sys-fs/ncdu: add 2.6-r1 Eric Joldasov
2024-10-25 21:33 ` [gentoo-dev] [PATCH v2 0/5] Ziglang eclasses for 0.13+ Eric Joldasov
2024-10-25 21:33   ` [gentoo-dev] [PATCH v2 1/5] zig-toolchain.eclass: new eclass Eric Joldasov
2024-10-25 21:33   ` [gentoo-dev] [PATCH v2 2/5] zig-build.eclass: " Eric Joldasov
2024-10-25 21:33   ` [gentoo-dev] [PATCH v2 3/5] dev-lang/zig: add 0.13.0-r1 Eric Joldasov
2024-10-25 21:33   ` [gentoo-dev] [PATCH v2 4/5] dev-lang/zig: sync 9999 with 0.13.0-r1 Eric Joldasov
2024-10-25 21:33   ` [gentoo-dev] [PATCH v2 5/5] sys-fs/ncdu: add 2.6-r1 Eric Joldasov
2024-12-13 20:07 ` [gentoo-dev] [PATCH v3 0/5] Zig: new eclasses, rewrite existing ebuilds to use them Eric Joldasov
2024-12-13 20:07   ` [gentoo-dev] [PATCH v3 1/5] zig-utils.eclass: new eclass Eric Joldasov
2024-12-13 20:07   ` [gentoo-dev] [PATCH v3 2/5] zig.eclass: " Eric Joldasov
2024-12-13 20:07   ` [gentoo-dev] [PATCH v3 3/5] dev-lang/zig: add 0.13.0-r2 Eric Joldasov
2024-12-13 20:07   ` [gentoo-dev] [PATCH v3 4/5] dev-lang/zig: sync 9999 with 0.13.0-r2 Eric Joldasov
2024-12-13 20:07   ` [gentoo-dev] [PATCH v3 5/5] sys-fs/ncdu: add 2.7-r1 Eric Joldasov

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20241024014626.31175-4-bratishkaerik@landless-city.net \
    --to=bratishkaerik@landless-city.net \
    --cc=bratishkaerik@getgoogleoff.me \
    --cc=gentoo-dev@lists.gentoo.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox